/* Copyright (c) 2009, Guillaume Delhumeau & Sophie Poullain
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Guillaume Delhumeau, Sophie Poullain nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package ecosysteme.gui;

import ecosysteme.model.Parameters;
import ecosysteme.model.Simulation;
import java.awt.BorderLayout;

/**
 * Fenêtre principale. A éditer de préférence avec NetBeans pour profiter
 * de l'éditeur GUI.
 * @author Guillaume Delhumeau & Sophie Poullain
 */
public class MainFrame extends javax.swing.JFrame {

    private Simulation simulation;

    /** Creates new form MainFrame */
    public MainFrame()
    {
        initComponents();
        simulation = new Simulation();
        pnlDisplay.add(simulation.getDisplay(), BorderLayout.CENTER);
        simulation.getDisplay().init();
        pnlStats.add(simulation.getStats().getDisplay(), BorderLayout.CENTER);
        Parameters.setDefaultValues();
        buttonGroupNbRochers.add(jRadioButton1);
        buttonGroupNbRochers.add(jRadioButton2);
        buttonGroupNbRochers.add(jRadioButton3);
        buttonGroupNbRochers.add(jRadioButton7);
        buttonGroupTailleRochers.add(jRadioButton4);
        buttonGroupTailleRochers.add(jRadioButton5);
        buttonGroupTailleRochers.add(jRadioButton6);
       
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroupNbRochers = new javax.swing.ButtonGroup();
        buttonGroupTailleRochers = new javax.swing.ButtonGroup();
        pnlMain = new javax.swing.JPanel();
        toolBar = new javax.swing.JToolBar();
        btNewMap = new javax.swing.JButton();
        btPlay = new javax.swing.JButton();
        mainSplit = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        pnlParameters = new javax.swing.JPanel();
        jPanelInitialParameters = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jRadioButton7 = new javax.swing.JRadioButton();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        jLabel18 = new javax.swing.JLabel();
        jRadioButton4 = new javax.swing.JRadioButton();
        jRadioButton5 = new javax.swing.JRadioButton();
        jRadioButton6 = new javax.swing.JRadioButton();
        jPanelParamFish = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabelFishShelfLife = new javax.swing.JLabel();
        jSliderFishShelfLife = new javax.swing.JSlider();
        jLabel4 = new javax.swing.JLabel();
        jLabelFishShelfLife1 = new javax.swing.JLabel();
        jSliderFishCopulation = new javax.swing.JSlider();
        jLabelFishAppetit = new javax.swing.JLabel();
        jSliderFishAppetit = new javax.swing.JSlider();
        jPanel4 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabelVide = new javax.swing.JLabel();
        btAddFish = new javax.swing.JButton();
        pnlParamShark = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabelSharkShelfLife = new javax.swing.JLabel();
        jSliderSharkShelfLife = new javax.swing.JSlider();
        jLabel3 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jSliderSharkCopulationTime = new javax.swing.JSlider();
        btAddShark = new javax.swing.JButton();
        jPanelEnvironnement = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabelPlanktonRegeneration = new javax.swing.JLabel();
        jSliderPlanktonRegeneration = new javax.swing.JSlider();
        jPanel2 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jPanelLegende = new javax.swing.JPanel();
        pnlLegendContainer = new javax.swing.JPanel();
        lblPlancton3Img = new javax.swing.JLabel();
        lblPlanctonImg = new javax.swing.JLabel();
        lblPlanctonText = new javax.swing.JLabel();
        lblPlancton2Img = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabelImageRequin = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabelImagePoisson = new javax.swing.JLabel();
        lblPlanctonText3 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        lblRocherImg1 = new javax.swing.JLabel();
        lblRocherImgLow = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        pnlDisplay = new javax.swing.JPanel();
        pnlStats = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Simulation Ecosyst\u00e8me");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });

        pnlMain.setLayout(new java.awt.BorderLayout());

        toolBar.setRollover(true);
        btNewMap.setText("Cr\u00e9er une nouvelle carte");
        btNewMap.setFocusable(false);
        btNewMap.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btNewMap.setMinimumSize(new java.awt.Dimension(200, 21));
        btNewMap.setPreferredSize(new java.awt.Dimension(200, 21));
        btNewMap.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btNewMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btNewMapActionPerformed(evt);
            }
        });

        toolBar.add(btNewMap);

        btPlay.setText("Lancer la simulation");
        btPlay.setFocusable(false);
        btPlay.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btPlay.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btPlay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btPlayActionPerformed(evt);
            }
        });

        toolBar.add(btPlay);

        pnlMain.add(toolBar, java.awt.BorderLayout.NORTH);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 100));
        pnlParameters.setLayout(new javax.swing.BoxLayout(pnlParameters, javax.swing.BoxLayout.Y_AXIS));

        pnlParameters.setMaximumSize(new java.awt.Dimension(200, 3767));
        pnlParameters.setPreferredSize(new java.awt.Dimension(325, 1000));
        jPanelInitialParameters.setLayout(new javax.swing.BoxLayout(jPanelInitialParameters, javax.swing.BoxLayout.Y_AXIS));

        jPanelInitialParameters.setBorder(javax.swing.BorderFactory.createTitledBorder("Param\u00e8tres initiaux de la simulation"));
        jLabel17.setText("Nombre de rochers:");
        jPanel3.add(jLabel17);

        jRadioButton7.setText("Aucun");
        jRadioButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton7ActionPerformed(evt);
            }
        });

        jPanel3.add(jRadioButton7);

        jRadioButton1.setText("1");
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        jPanel3.add(jRadioButton1);

        jRadioButton2.setText("2");
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });

        jPanel3.add(jRadioButton2);

        jRadioButton3.setSelected(true);
        jRadioButton3.setText("3");
        jRadioButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton3ActionPerformed(evt);
            }
        });

        jPanel3.add(jRadioButton3);

        jPanelInitialParameters.add(jPanel3);

        jLabel18.setText("Taille des rochers");
        jPanel5.add(jLabel18);

        jRadioButton4.setText("petite");
        jRadioButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton4ActionPerformed(evt);
            }
        });

        jPanel5.add(jRadioButton4);

        jRadioButton5.setSelected(true);
        jRadioButton5.setText("moyenne");
        jRadioButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton5ActionPerformed(evt);
            }
        });

        jPanel5.add(jRadioButton5);

        jRadioButton6.setText("grande");
        jRadioButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton6ActionPerformed(evt);
            }
        });

        jPanel5.add(jRadioButton6);

        jPanelInitialParameters.add(jPanel5);

        pnlParameters.add(jPanelInitialParameters);

        jPanelParamFish.setLayout(new javax.swing.BoxLayout(jPanelParamFish, javax.swing.BoxLayout.Y_AXIS));

        jPanelParamFish.setBorder(javax.swing.BorderFactory.createTitledBorder("Param\u00e8tre relatifs aux poissons"));
        jLabel1.setText("    ");
        jPanelParamFish.add(jLabel1);
        jLabel1.getAccessibleContext().setAccessibleName("");

        jLabelFishShelfLife.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelFishShelfLife.setText("Esp\u00e9rance de vie des poissons (en jours)");
        jPanelParamFish.add(jLabelFishShelfLife);

        jSliderFishShelfLife.setMajorTickSpacing(10);
        jSliderFishShelfLife.setMinorTickSpacing(5);
        jSliderFishShelfLife.setPaintLabels(true);
        jSliderFishShelfLife.setPaintTicks(true);
        jSliderFishShelfLife.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderFishShelfLifeStateChanged(evt);
            }
        });

        jPanelParamFish.add(jSliderFishShelfLife);

        jLabel4.setText("    ");
        jPanelParamFish.add(jLabel4);

        jLabelFishShelfLife1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelFishShelfLife1.setText("Temps minimal entre deux reproductions");
        jPanelParamFish.add(jLabelFishShelfLife1);

        jSliderFishCopulation.setMajorTickSpacing(10);
        jSliderFishCopulation.setMinorTickSpacing(5);
        jSliderFishCopulation.setPaintLabels(true);
        jSliderFishCopulation.setPaintTicks(true);
        jSliderFishCopulation.setValue(30);
        jSliderFishCopulation.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderFishCopulationStateChanged(evt);
            }
        });

        jPanelParamFish.add(jSliderFishCopulation);

        jLabelFishAppetit.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelFishAppetit.setText("App\u00e9tit poissons");
        jPanelParamFish.add(jLabelFishAppetit);

        jSliderFishAppetit.setMajorTickSpacing(10);
        jSliderFishAppetit.setMaximum(10);
        jSliderFishAppetit.setMinimum(1);
        jSliderFishAppetit.setMinorTickSpacing(5);
        jSliderFishAppetit.setToolTipText("");
        jSliderFishAppetit.setValue(5);
        jSliderFishAppetit.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderFishAppetitStateChanged(evt);
            }
        });

        jPanelParamFish.add(jSliderFishAppetit);

        jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setMaximumSize(new java.awt.Dimension(2147483647, 28));
        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel10.setText("faible");
        jLabel10.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel1.add(jLabel10, java.awt.BorderLayout.WEST);

        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel11.setText("fort");
        jLabel11.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel1.add(jLabel11, java.awt.BorderLayout.EAST);

        jPanel4.add(jPanel1);

        jLabelVide.setText("   ");
        jPanel4.add(jLabelVide);

        jPanelParamFish.add(jPanel4);

        btAddFish.setText("Cr\u00e9er de nouveaux poissons");
        btAddFish.setFocusable(false);
        btAddFish.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btAddFish.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btAddFish.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btAddFishActionPerformed(evt);
            }
        });

        jPanelParamFish.add(btAddFish);

        pnlParameters.add(jPanelParamFish);

        pnlParamShark.setLayout(new javax.swing.BoxLayout(pnlParamShark, javax.swing.BoxLayout.Y_AXIS));

        pnlParamShark.setBorder(javax.swing.BorderFactory.createTitledBorder("Param\u00e8res relatifs aux requins"));
        jLabel2.setText("    ");
        pnlParamShark.add(jLabel2);

        jLabelSharkShelfLife.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelSharkShelfLife.setText("Esp\u00e9rance de vie des requins (en jours)");
        pnlParamShark.add(jLabelSharkShelfLife);

        jSliderSharkShelfLife.setMajorTickSpacing(10);
        jSliderSharkShelfLife.setMinorTickSpacing(5);
        jSliderSharkShelfLife.setPaintLabels(true);
        jSliderSharkShelfLife.setPaintTicks(true);
        jSliderSharkShelfLife.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderSharkShelfLifeStateChanged(evt);
            }
        });

        pnlParamShark.add(jSliderSharkShelfLife);

        jLabel3.setText("    ");
        pnlParamShark.add(jLabel3);

        jLabel21.setText("Temps minimal entre deux reproductions");
        pnlParamShark.add(jLabel21);

        jSliderSharkCopulationTime.setMajorTickSpacing(50);
        jSliderSharkCopulationTime.setMaximum(500);
        jSliderSharkCopulationTime.setMinorTickSpacing(50);
        jSliderSharkCopulationTime.setPaintLabels(true);
        jSliderSharkCopulationTime.setPaintTicks(true);
        jSliderSharkCopulationTime.setValue(220);
        jSliderSharkCopulationTime.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 5, 1));
        jSliderSharkCopulationTime.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderSharkCopulationTimeStateChanged(evt);
            }
        });

        pnlParamShark.add(jSliderSharkCopulationTime);

        btAddShark.setText("Cr\u00e9er un nouveau requin");
        btAddShark.setFocusable(false);
        btAddShark.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btAddShark.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btAddShark.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btAddSharkActionPerformed(evt);
            }
        });

        pnlParamShark.add(btAddShark);

        pnlParameters.add(pnlParamShark);
        pnlParamShark.getAccessibleContext().setAccessibleName("Param\u00e8tres initiaux");
        pnlParamShark.getAccessibleContext().setAccessibleDescription("");

        jPanelEnvironnement.setLayout(new javax.swing.BoxLayout(jPanelEnvironnement, javax.swing.BoxLayout.Y_AXIS));

        jPanelEnvironnement.setBorder(javax.swing.BorderFactory.createTitledBorder("Param\u00e8tres relatifs \u00e0 l'environnement"));
        jLabel5.setText("    ");
        jPanelEnvironnement.add(jLabel5);

        jLabelPlanktonRegeneration.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelPlanktonRegeneration.setText("Temps de r\u00e9g\u00e9n\u00e9ration du plancton");
        jLabelPlanktonRegeneration.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jPanelEnvironnement.add(jLabelPlanktonRegeneration);

        jSliderPlanktonRegeneration.setMajorTickSpacing(10);
        jSliderPlanktonRegeneration.setMaximum(10);
        jSliderPlanktonRegeneration.setMinorTickSpacing(5);
        jSliderPlanktonRegeneration.setToolTipText("");
        jSliderPlanktonRegeneration.setValue(5);
        jSliderPlanktonRegeneration.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderPlanktonRegenerationStateChanged(evt);
            }
        });

        jPanelEnvironnement.add(jSliderPlanktonRegeneration);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.setMaximumSize(new java.awt.Dimension(32767, 28));
        jLabel6.setText("lent");
        jLabel6.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel2.add(jLabel6, java.awt.BorderLayout.WEST);

        jLabel7.setText("rapide");
        jLabel7.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jPanel2.add(jLabel7, java.awt.BorderLayout.EAST);

        jPanelEnvironnement.add(jPanel2);

        pnlParameters.add(jPanelEnvironnement);

        jPanelLegende.setLayout(new java.awt.BorderLayout());

        jPanelLegende.setBorder(javax.swing.BorderFactory.createTitledBorder("L\u00e9gende"));
        pnlLegendContainer.setLayout(new java.awt.GridBagLayout());

        lblPlancton3Img.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblPlancton3Img.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/legend/plancton_low.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(lblPlancton3Img, gridBagConstraints);

        lblPlanctonImg.setBackground(new java.awt.Color(51, 102, 255));
        lblPlanctonImg.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblPlanctonImg.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/legend/plancton_high.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(lblPlanctonImg, gridBagConstraints);

        lblPlanctonText.setText("Oc\u00e9an (forte densit\u00e9 de plancton)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        pnlLegendContainer.add(lblPlanctonText, gridBagConstraints);

        lblPlancton2Img.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblPlancton2Img.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/legend/plancton_low_low.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(lblPlancton2Img, gridBagConstraints);

        jLabel15.setText("Oc\u00e9an (faible densit\u00e9 de plancton)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        pnlLegendContainer.add(jLabel15, gridBagConstraints);

        jLabel14.setBackground(new java.awt.Color(0, 153, 255));
        jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel14.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/legend/rocher.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(jLabel14, gridBagConstraints);

        jLabel16.setText("Rocher (forte densit\u00e9 de plancton)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        pnlLegendContainer.add(jLabel16, gridBagConstraints);

        jLabel13.setText("Requin");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        pnlLegendContainer.add(jLabel13, gridBagConstraints);

        jLabelImageRequin.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelImageRequin.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/shark/SHARK_initial.png")));
        jLabelImageRequin.setPreferredSize(new java.awt.Dimension(30, 35));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(jLabelImageRequin, gridBagConstraints);

        jLabel12.setText("Poisson");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        pnlLegendContainer.add(jLabel12, gridBagConstraints);

        jLabelImagePoisson.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelImagePoisson.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/fish_legend.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(jLabelImagePoisson, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        pnlLegendContainer.add(lblPlanctonText3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        pnlLegendContainer.add(jLabel8, gridBagConstraints);

        jLabel9.setText("  ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        pnlLegendContainer.add(jLabel9, gridBagConstraints);

        lblRocherImg1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblRocherImg1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/legend/rocher_high.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(lblRocherImg1, gridBagConstraints);

        lblRocherImgLow.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblRocherImgLow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ecosysteme/resources/legend/rocher_low.png")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        pnlLegendContainer.add(lblRocherImgLow, gridBagConstraints);

        jLabel19.setText("   ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        pnlLegendContainer.add(jLabel19, gridBagConstraints);

        jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel20.setText("Rocher (faible densit\u00e9 de plancton)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        pnlLegendContainer.add(jLabel20, gridBagConstraints);

        jPanelLegende.add(pnlLegendContainer, java.awt.BorderLayout.NORTH);

        pnlParameters.add(jPanelLegende);

        jScrollPane1.setViewportView(pnlParameters);

        mainSplit.setLeftComponent(jScrollPane1);

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(100, 100));
        pnlDisplay.setLayout(new java.awt.BorderLayout());

        pnlDisplay.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        pnlDisplay.setPreferredSize(new java.awt.Dimension(1000, 1000));
        jTabbedPane1.addTab("Simulation", pnlDisplay);

        pnlStats.setLayout(new java.awt.BorderLayout());

        jTabbedPane1.addTab("Statistiques", pnlStats);

        mainSplit.setRightComponent(jTabbedPane1);

        pnlMain.add(mainSplit, java.awt.BorderLayout.CENTER);

        getContentPane().add(pnlMain, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jSliderFishCopulationStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderFishCopulationStateChanged
    Parameters.FISH_NB_ITERATIONS_ENTRE_COPULATIONS = jSliderFishCopulation.getValue();
    }//GEN-LAST:event_jSliderFishCopulationStateChanged

    private void jSliderSharkCopulationTimeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderSharkCopulationTimeStateChanged
    Parameters.SHARK_NB_ITERATIONS_ENTRE_COPULATIONS = jSliderSharkCopulationTime.getValue();
    }//GEN-LAST:event_jSliderSharkCopulationTimeStateChanged

private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
    simulation.getDisplay().init();
}//GEN-LAST:event_formComponentShown

private void btPlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btPlayActionPerformed
    
    if (simulation.isRunning())
    {
        if (simulation.isPause())
        {
            simulation.setPause(false);
            btPlay.setText("Mettre en pause");
        } else
        {
            simulation.setPause(true);
            btPlay.setText("Reprendre la simulation");
        }
    } else
    {
        simulation.init(false);
        simulation.start();
        btPlay.setText("Mettre en pause");
    }
}//GEN-LAST:event_btPlayActionPerformed

private void btAddFishActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btAddFishActionPerformed
    simulation.createFish();
}//GEN-LAST:event_btAddFishActionPerformed

private void jSliderFishShelfLifeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderFishShelfLifeStateChanged
    Parameters.FISH_SHELF_LIFE = jSliderFishShelfLife.getValue() * 100;
}//GEN-LAST:event_jSliderFishShelfLifeStateChanged

private void jSliderFishAppetitStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderFishAppetitStateChanged
    Parameters.FISH_APPETIT = jSliderFishAppetit.getValue();
}//GEN-LAST:event_jSliderFishAppetitStateChanged

private void jSliderPlanktonRegenerationStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderPlanktonRegenerationStateChanged
    Parameters.PLANKTON_REGENERATION = jSliderPlanktonRegeneration.getValue()*2;
}//GEN-LAST:event_jSliderPlanktonRegenerationStateChanged

private void btAddSharkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btAddSharkActionPerformed
    simulation.createShark();
}//GEN-LAST:event_btAddSharkActionPerformed

private void jSliderSharkShelfLifeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderSharkShelfLifeStateChanged
    Parameters.SHARK_SHELF_LIFE = jSliderSharkShelfLife.getValue() * 50;
}//GEN-LAST:event_jSliderSharkShelfLifeStateChanged

private void btNewMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btNewMapActionPerformed

    if (simulation.isRunning())
    {
        simulation.stop();
		}
		simulation.init(true);
    btPlay.setText("Lancer la simulation");

}//GEN-LAST:event_btNewMapActionPerformed


private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        Parameters.SAFE_ZONES_NUMBER = 2;
        jRadioButton4.setEnabled(true);
        jRadioButton5.setEnabled(true);
        jRadioButton6.setEnabled(true);
}//GEN-LAST:event_jRadioButton2ActionPerformed

private void jRadioButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton5ActionPerformed
    Parameters.SAFE_ZONES_SIZE = 18;
}//GEN-LAST:event_jRadioButton5ActionPerformed

private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        Parameters.SAFE_ZONES_NUMBER = 1;
        jRadioButton4.setEnabled(true);
         jRadioButton5.setEnabled(true);
         jRadioButton6.setEnabled(true);
}//GEN-LAST:event_jRadioButton1ActionPerformed

private void jRadioButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton3ActionPerformed
        Parameters.SAFE_ZONES_NUMBER = 3;
        jRadioButton4.setEnabled(true);
         jRadioButton5.setEnabled(true);
         jRadioButton6.setEnabled(true);
}//GEN-LAST:event_jRadioButton3ActionPerformed

private void jRadioButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton4ActionPerformed
        Parameters.SAFE_ZONES_SIZE= 10;
}//GEN-LAST:event_jRadioButton4ActionPerformed

private void jRadioButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton6ActionPerformed
        Parameters.SAFE_ZONES_SIZE = 25;
}//GEN-LAST:event_jRadioButton6ActionPerformed

private void jRadioButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton7ActionPerformed
         Parameters.SAFE_ZONES_NUMBER = 0;
         jRadioButton4.setEnabled(false);
         jRadioButton5.setEnabled(false);
         jRadioButton6.setEnabled(false);
}//GEN-LAST:event_jRadioButton7ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btAddFish;
    private javax.swing.JButton btAddShark;
    private javax.swing.JButton btNewMap;
    private javax.swing.JButton btPlay;
    private javax.swing.ButtonGroup buttonGroupNbRochers;
    private javax.swing.ButtonGroup buttonGroupTailleRochers;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelFishAppetit;
    private javax.swing.JLabel jLabelFishShelfLife;
    private javax.swing.JLabel jLabelFishShelfLife1;
    private javax.swing.JLabel jLabelImagePoisson;
    private javax.swing.JLabel jLabelImageRequin;
    private javax.swing.JLabel jLabelPlanktonRegeneration;
    private javax.swing.JLabel jLabelSharkShelfLife;
    private javax.swing.JLabel jLabelVide;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanelEnvironnement;
    private javax.swing.JPanel jPanelInitialParameters;
    private javax.swing.JPanel jPanelLegende;
    private javax.swing.JPanel jPanelParamFish;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton4;
    private javax.swing.JRadioButton jRadioButton5;
    private javax.swing.JRadioButton jRadioButton6;
    private javax.swing.JRadioButton jRadioButton7;
    private javax.swing.JScrollPane jScrollPane1;
    public static javax.swing.JSlider jSliderFishAppetit;
    private javax.swing.JSlider jSliderFishCopulation;
    public static javax.swing.JSlider jSliderFishShelfLife;
    public static javax.swing.JSlider jSliderPlanktonRegeneration;
    public static javax.swing.JSlider jSliderSharkCopulationTime;
    public static javax.swing.JSlider jSliderSharkShelfLife;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lblPlancton2Img;
    private javax.swing.JLabel lblPlancton3Img;
    private javax.swing.JLabel lblPlanctonImg;
    private javax.swing.JLabel lblPlanctonText;
    private javax.swing.JLabel lblPlanctonText3;
    private javax.swing.JLabel lblRocherImg1;
    private javax.swing.JLabel lblRocherImgLow;
    private javax.swing.JSplitPane mainSplit;
    private javax.swing.JPanel pnlDisplay;
    private javax.swing.JPanel pnlLegendContainer;
    private javax.swing.JPanel pnlMain;
    private javax.swing.JPanel pnlParamShark;
    private javax.swing.JPanel pnlParameters;
    private javax.swing.JPanel pnlStats;
    private javax.swing.JToolBar toolBar;
    // End of variables declaration//GEN-END:variables
    public static int getShelfFishLife()
    {
        return jSliderFishShelfLife.getValue() * 1000;
    }
}
